<!doctype html>
<html>

  <head>
    <title>Submarine Control Terminal</title>
    <link rel="stylesheet" href="/rsapp/fontawesome/css/all.css" />
    <link rel="stylesheet" href="/rsapp/css/animate.css" />
    <link rel="stylesheet" href="/rsapp/bulma/css/bulma.css" />
    <link rel="stylesheet" href="/index.css" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <script src="/rsapp/socket.js"></script>
    <script src="/rsapp/rx.js"></script>
    <script src="/rsapp/three.js"></script>
    <script src="/rsapp/STLLoader.js"></script>
    <script src="/rsapp/riot-compiler.min.js"></script>
  </head>

  <body>
    <section class="section">
      <!-- <div class="container"> -->
        <div class="tile is-ancestor is-vertical">
          <!--

          Header Row

          -->
          <div class="tile">
            <div class="tile is-parent is-vertical is-7">
              <div class="tile is-child" style="flex-grow:0;">
                <h1 class="title">Submarine Control Terminal 
                  <button class="button is-primary" onclick="socket.emit('imu/setPressureZero')">
                    <span class="is-small">Reset Pressure</span>
                  </button>
                  <button class="button is-primary" onclick="socket.emit('power/enable')">
                    <span class="is-small">Enable Motor Power</span>
                  </button>
                  <button class="button is-danger" onclick="socket.emit('power/disable')">
                    <span class="is-small">Disable Motor Power</span>
                  </button>
                  </h1>
                <h2 class="subtitle">Utah State Robosub Team</h3>
              </div>
              <div class="tile is-child box is-paddingless consolewrap" style="flex-grow: 1;" id="consolewrap">
                <i class="fas fa-lock console-scrolllock" onclick="scrolllock=!scrolllock;document.getElementById('consolewrap').classList.toggle('scrolllock')"></i>
                <i class="fas fa-unlock-alt console-scrolllock" onclick="scrolllock=!scrolllock;document.getElementById('consolewrap').classList.toggle('scrolllock')"></i>
                <i class="fas fa-expand-arrows-alt console-fullscreen" onclick="document.getElementById('consolewrap').classList.toggle('active')"></i>
<pre  class="is-margninless has-background-dark has-text-white console"  id="console">
<span class="has-text-warn">Waiting for console...</span>
</pre>
              </div>
            </div>
            <div class="tile is-parent">
              <div class="tile is-child" id="submodel">
              </div>
              <canvas id="chartcanvas"></canvas>
              <rg-chart></rg-chart>
            </div>
          </div>
        </div>
        <controls></controls>
      <!-- </div> -->
    </section>
    <!--<img src="http://192.168.1.101:8082" class="shrinkToFit" width="500">-->
    <!--<img src="http://192.168.1.101:8083" class="shrinkToFit" width="500">-->
    <!--<img src="http://192.168.1.101:8084" class="shrinkToFit" width="500">-->
    <script src="/index.js"></script>
    <script src="/rsapp/joycontrols.js"></script>
    <script src="/rsapp/OrbitControls.js"></script>
    <script src="/rsapp/submodel.js"></script>
    <!-- Riot Tags -->
    <script src="/rsapp/tags/directioncontrol.tag" type="riot/tag"></script>
    <script src="/rsapp/tags/pidcontrol.tag" type="riot/tag"></script>
    <script src="/rsapp/tags/controls.tag" type="riot/tag"></script>
    <script src="/rsapp/chart.min.js"></script>
    <script src="/rsapp/imucharts.js"></script>
    <script>
    /* global riot, setThrottle, setSteering, setHeading, setDive, setDepth, setDiveTrim, setPitch  */
      riot.mount('controls',
      {
        controls: [
          [
            {
              title: "Thruster",
              update: (amount) => emit('tank/throttle', amount),
              range: {
                max: 1,
                min: -1,
                wrapAround: false
              }
            },
            {
              title: "Steering",
              update: (amount) => emit('tank/steering', amount),
              horizontal: true,
              range: {
                max: 1,
                min: -1,
                wrapAround: false
              }
            },
            {
              title: "Heading",
              update: (target) => emit('tank/heading', target),
              horizontal: true,
              range: {
                max: 3.10,
                min: -3.10,
                wrapAround: true
              }
            },
          ],
          [
            {
              title: "Dive",
              update: (amount) => emit('dive/power', amount),
              range: {
                max: 1,
                min: -1,
                wrapAround: false
              }
            },
            {
              title: "Depth",
              slider: true,
              update: (target) => emit('dive/depth', target),
              range: {
                initial: 0,
                delta: -10,
                max: 1000,
                min: -1000,
                wrapAround: false
              }
            },
            {
              title: "Dive Trim",
              update: (amount) => emit('dive/trim', amount),
              horizontal: true,
              range: {
                max: 1,
                min: -1,
                wrapAround: false
              }
            },
            {
              title: "Pitch",
              update: (target) => emit('dive/pitch', target),
              horizontal: true,
              range: {
                max: 3.10,
                min: -3.10,
                initial: -2.4,
                wrapAround: true
              }
            },
          ],
          [
            {
              title: "Heading PID Gains",
              update: (p, i, d) => emit('tank/heading/pid/angle', p, i, d),
              type: "pidcontrol"
            },
            {
              title: "Heading Velocity PID Gains",
              update: (p, i, d) => emit('tank/heading/pid/velocity', p, i, d),
              type: "pidcontrol"
            },
          ],
          [
            {
              title: "Depth PID Gains",
              update: (p, i, d) => emit('dive/depth/pid', p, i, d),
              type: "pidcontrol"
            },
            {
              title: "Pitch PID Gains",
              update: (p, i, d) => emit('dive/pitch/pid', p, i, d),
              type: "pidcontrol"
            },
          ]
        ]
      })

    </script>
  </body>

</html>
